# Released under the GNU Lesser General Public License, v2.1 or later
# Copyright (c) 2007 Phil Jones <interstar@gmail.com>

""" This is what GeekWeaver trees are build of"""
from xml.dom.minidom import parse, parseString

class GWNode :
    """This is """
    
    def __init__(self, text='') :
        self.text = text
        self.children = []

    def addChild(self, tNode) :
        if tNode.__class__ == str :
            self.children.append(GWNode(tNode))
        else:
            self.children.append(tNode)
        return self

    def size(self,t) :
        return 1 + sum([self.size(x) for x in t.children])


    
class OpmlToTree :
    """Mindlessly simplistic and brittle. Uses the minidom"""

    def __init__(self, s) :
        self.dom = parseString(s) # makes the dom tree
        self.root = GWNode('root')
        tag = self.dom.getElementsByTagName('body')[0]
        for child in tag.childNodes :
            if child.nodeType != child.TEXT_NODE :
                self.recurse(self.root, child)
        
    def recurse(self, parent, tag) :
        node = GWNode(tag.getAttribute('text'))
        for child in tag.childNodes :
            if child.nodeType != child.TEXT_NODE :
                self.recurse(node, child)
        parent.addChild(node)
                

